part of viltage;

class State {
  List<CharNode> charNodes = new List<CharNode>();
  List<ImgNode> imgNodes = new List<ImgNode>();
  
  render(int x, int y, List<List<Node>> nodeArray) {
    for(int i = 0; i < charNodes.length; i++) {
      if(y+charNodes[i].y < nodeArray.length && y+charNodes[i].y >= 0 &&
         x+charNodes[i].x < nodeArray[0].length  && x+charNodes[i].x >= 0
         && charNodes[i].visible) {
        nodeArray[y+charNodes[i].y][x+charNodes[i].x] = charNodes[i];
      }
    }
    for(int i = 0; i < imgNodes.length; i++) {
      if(y+imgNodes[i].y < nodeArray.length && y+imgNodes[i].y >= 0 &&
         x+imgNodes[i].x < nodeArray[0].length  && x+imgNodes[i].x >= 0
         && imgNodes[i].visible) {
        nodeArray[y+imgNodes[i].y][x+imgNodes[i].x] = imgNodes[i];
      }
    }
  }
  
  clear() {
    charNodes.clear();
    imgNodes.clear();
  }

  /* Text Nodes */
  CharNode createCharNode(int x, int y, String text) {
    CharNode cn;
    cn = new CharNode(x, y, text);
    charNodes.add(cn);
    return cn;
  }
  
  List<CharNode> createCharNodeLine(int x, int y, bool horizontal, String text) {
    List<CharNode> charNodes = new List<CharNode>();
    for(int i = 0; i < text.length; i++) {
      if(horizontal) charNodes.add(createCharNode(x + i, y, text[i]));
      else charNodes.add(createCharNode(x, y + i, text[i]));
    }
    return charNodes;
  }
  
  List<List<CharNode>> createCharNodeRect(int x, int y, List<String> text) {
    List<List<CharNode>> charNodes = new List<List<CharNode>>();
    for(int i = 0; i < text.length; i++) {
      charNodes.add(createCharNodeLine(x, y+i, true, text[i]));
    }
    return charNodes;
  }
  
  /* Image Nodes */
  ImgNode createImgNode(int x, int y, CanvasImageSource img, VilTAGE viltage, {double offX, double offY, String color}) {
    ImgNode imgn;
    imgn = new ImgNode(x, y, img, viltage, offX: offX, offY: offY, color:color);
    imgNodes.add(imgn);
    return imgn;
  }
  
  List<ImgNode> createImgNodeLine(int x, int y, bool horizontal, List<CanvasImageSource> img, VilTAGE viltage, {double offX, double offY, String color}) {
    List<ImgNode> imgNodes = new List<ImgNode>();
    for(int i = 0; i < img.length; i++) {
      if(horizontal) imgNodes.add(createImgNode(x + i, y, img[i], viltage, offX: offX, offY: offY, color:color));
      else imgNodes.add(createImgNode(x, y + i, img[i], viltage, offX: offX, offY: offY, color:color));
    }
    return imgNodes;
  }
  
  List<List<ImgNode>> createImgNodeRect(int x, int y, List<List<CanvasImageSource>> img, VilTAGE viltage, {double offX, double offY, String color}) {
    List<List<ImgNode>> imgNodes = new List<List<ImgNode>>();
    for(int i = 0; i < img.length; i++) {
      imgNodes.add(createImgNodeLine(x, y+i, true, img[i], viltage, offX: offX, offY: offY, color:color));
    }
    return imgNodes;
  }
}